=== modified file 'src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java'
--- src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java	2021-06-10 11:50:04 +0000
+++ src/com/goldencode/p2j/ui/client/gui/theme/ClassicTheme.java	2021-06-18 18:47:18 +0000
@@ -6581,214 +6619,420 @@
     * @param   disabledFore
     *          Disabled widget foreground color.
     */
-   public final <N extends TreeNodeEntry> void drawTreeViewBody(final GuiDriver gd,
-                                                                final GuiColorResolver gc,
-                                                                final GuiFontResolver.FontCache font,
-                                                                final TreeGuiImpl tree,
-                                                                final List<TreeGuiImpl.TreeNode<N>> nodes,
-                                                                final TreeGuiImpl.TreeNode<N> currentNode,
-                                                                final int valueIndex,
-                                                                final int width,
-                                                                final ColorRgb selectionBack,
-                                                                final ColorRgb selectionFore,
-                                                                final ColorRgb disabledFore)
+   public final void drawTreeViewBody(final GuiDriver gd,
+                                      final GuiColorResolver gc,
+                                      final GuiFontResolver.FontCache font,
+                                      final TreeGuiImpl tree,
+                                      final TreeNode topNode,
+                                      final TreeNode currentNode,
+                                      final int valueIndex,
+                                      final int width,
+                                      final int height,
+                                      final ColorRgb selectionBack,
+                                      final ColorRgb selectionFore,
+                                      final ColorRgb disabledFore)
    {
       // fill the background
-      // 
       // FIXME: filling background does not change anything at the moment, so it is commented for now
       // gd.setColor(gc.bgColor);
       // gd.fillRect(0, 0, bodyDim.width, bodyDim.height);
 
-      if (nodes != null && !nodes.isEmpty())
-      {
-         gd.setGuiFont(font.font);
-         gd.setFontStyle(font.font.style);
-         final int rowHeight = getTreeViewNodeHeight(font);
-
-         drawTreeViewNodes(gd, gc, tree, nodes, currentNode, valueIndex, 0, font, rowHeight,
-                  width, 0, tree.isEnabled(), selectionBack, selectionFore, disabledFore);
+      if (topNode == null)
+      {
+         return;
+      }
+      
+      gd.setGuiFont(font.font);
+      gd.setFontStyle(font.font.style);
+      final int rowHeight = getTreeViewNodeHeight(font);
+
+      // Collect visible nodes that fit into the widget height, their row numbers and parents
+      final Map<TreeNode, Integer> node2row = new IdentityHashMap<>();
+      final Set<TreeNode> parents = Collections.newSetFromMap(new IdentityHashMap<>()); 
+      final int nodesFit = (height + rowHeight - 1) / rowHeight;
+      int row = 0; 
+      for (TreeNode node = topNode; node != null && row < nodesFit; node = node.nextVisible())
+      {
+         node2row.put(node, Integer.valueOf(row));
+         parents.add(node.parent);
+         row++; 
+      }
+      
+      // Add ancestors of the top node
+      for (TreeNode p = topNode.parent; p != null; p = p.parent)
+      {
+         parents.add(p);
+      }
+      
+      final int signOff = TREEVIEW_EXPAND_ICON_SIZE / 2;
+
+      // draw vertical lines from parents down to the last children
+      gd.setColor(TREEVIEW_DOTS_COLOR);
+      for (final TreeNode p : parents)
+      {
+         final int level = p.getLevel();
+         final int expandIconLeftX = TREEVIEW_INNER_PADDING + TREEVIEW_EXPAND_ICON_OFFSET
+                  + getTreeViewNodeHorizontalOffset(level);
+         final int verticalDotsX = expandIconLeftX + signOff;
+         final Integer parentRow = node2row.get(p);
+         final int top = parentRow != null ? rowHeight * parentRow.intValue() + rowHeight / 2 : 0;
+
+         final List<TreeNode> children = p.nodes;
+         final TreeNode lastChild = children.get(children.size() - 1);
+
+         // Skip lines completely above the visible area
+         if (lastChild != topNode && lastChild.isDFTBeforeThan(topNode))
+         {
+            continue;
+         }
+         
+         final Integer lastChildRow = node2row.get(lastChild);
+         final int bottom = lastChildRow != null
+                  ? rowHeight * lastChildRow.intValue() + rowHeight / 2
+                  : height;
+         drawDottedVerticalLine(gd, verticalDotsX, top, bottom);
+      }
+      
+      final TreeConfig c = tree.config();
+      final boolean configShowExpandIcon = c.showExpandIcon;
+      final boolean enabled = tree.isEnabled();
+      final int hSignOff = signOff / 2;
+      for (final TreeNode node : node2row.keySet())
+      {
+         final int level = node.getLevel();
+         final int contentX = getTreeViewNodeContentHorizontalOffset(level);
+         final int expandIconLeftX = TREEVIEW_INNER_PADDING + TREEVIEW_EXPAND_ICON_OFFSET
+                  + getTreeViewNodeHorizontalOffset(level - 1);
+
+         int r = node2row.get(node).intValue();
+         final int iconY = rowHeight * r + (rowHeight - TREEVIEW_EXPAND_ICON_SIZE) / 2;
+
+         // horizontal dots from the center of expand icon to the center of node icon.
+         gd.setColor(TREEVIEW_DOTS_COLOR);
+         final int horizontalDotsY = iconY + signOff;
+         final int startX = expandIconLeftX + hSignOff + 2;
+         final int endX = signOff + contentX + 3;
+         for (int x = startX; x < endX; x += 2)
+         {
+            gd.drawLine(x, horizontalDotsY, x, horizontalDotsY);
+         }
+         
+         final TreeNodeEntry nodeValue = node.value;
+         final Object value = nodeValue.getValue(valueIndex);      
+         final String text = value == null ? "" : value.toString();
+         final boolean nodeSelected = node == currentNode;
+         final ImageWrapper img = tree.getNodeImage(node, nodeSelected);
+         final int imageWidth = img != null ? img.getWidth() : 0;         
+         final int textX = getTreeViewNodeLabelHorizontalOffset(level, imageWidth);
+
+         // node icon
+         if (img != null)
+         {
+            final int imageHeight = img.getHeight();
+            final int imageY = getTreeViewNodeImageVerticalOffset(r, rowHeight, imageHeight);
+            gd.drawImage(img, contentX - 2, imageY, imageWidth, imageHeight, 0, 0, false, false,
+                     false, false);
+         }
+
+         // Expand/collapse button
+         if (configShowExpandIcon && nodeValue.hasChildren)
+         {
+            final int expandIconDimension = TREEVIEW_EXPAND_ICON_SIZE - 1;
+
+            // Button background
+            gd.setColor(gc.bgColor);
+            gd.fillRect(expandIconLeftX, iconY, expandIconDimension, expandIconDimension);
+            
+            // Button border
+            gd.setColor(TREEVIEW_DOTS_COLOR);
+            gd.drawRect(expandIconLeftX, iconY, expandIconDimension, expandIconDimension);
+
+            // the "-" sign line
+            gd.setColor(TREEVIEW_EXPAND_ICON_COLOR);
+            gd.drawLine(expandIconLeftX + hSignOff, iconY + signOff,
+                     expandIconLeftX + hSignOff + signOff, iconY + signOff);
+
+            // the line tom make "+" sign
+            if (!node.value.expanded)
+            {
+               gd.drawLine(expandIconLeftX + signOff, iconY + hSignOff, expandIconLeftX + signOff,
+                        iconY + hSignOff + signOff);
+            }
+         }
+
+//         drawTreeListCell(gd,
+//                  font,
+//                  tree,
+//                  cellWidth,
+//                  rowHeight,
+//                  fgColor,
+//                  bgSelColor,
+//                  bgColor,
+//                  Object value,
+//                  align,
+//                  selected,
+//                  final TreeListConfig.Column.DataType dataType);
+         
+ 
+         // node text highlight
+         if (nodeSelected)
+         {
+            gd.setColor(selectionBack);
+            gd.fillRect(textX, rowHeight * r, width, rowHeight);
+         }
+
+         // node text color
+         final ColorRgb textColor;
+         if (enabled && nodeSelected)
+         {
+            textColor = selectionFore;
+         }
+         else if (enabled)
+         {
+            textColor = gc.fgColor;
+         }
+         else
+         {
+            textColor = disabledFore;
+         }
+
+         // node text
+         gd.setColor(textColor);
+         final int textY = getTreeViewNodeVerticalOffset(r, rowHeight, font);
+         gd.drawString(text, textX + 2, textY);
+
       }
    }
 
    /**
-    * Draws a treeview node.
+    * Draws treeview body.
     *
     * @param   gd
     *          GUI driver.
     * @param   gc
     *          Color resolver.
+    * @param   fc
+    *          Text font.
     * @param   tree
     *          Tree widget, the owner of the tree body.
-    * @param   node
-    *          Node to draw.
+    * @param   topNode
+    *          the first node to draw or {@code null} for an empty tree.
     * @param   currentNode
-    *          Current node.
-    * @param   valueIndex
-    *          The index of the value to be displayed. For TREEVIEW widget this is always 0.
-    * @param   rowIdx
-    *          Row index.
-    * @param   parentRowIdx
-    *          Parent row index.
-    * @param   prevExpIcoRowIdx
-    *          Row index of the previous sibling with expand icon.
-    * @param   font
-    *          The font to use.
-    * @param   nodeHeight
-    *          Node height.
-    * @param   rowWidth
-    *          Row width.
-    * @param   level
-    *          Tree level.
-    * @param   enabled
-    *          Widget enabled state.
-    * @param   firstChild
-    *          Whether the node is the first node in its parent collection.
-    * @param   lastChild
-    *          Whether the node is the last node in its parent collection.
-    * @param   showExpandIcon
-    *          Make the expand icon visible or invisible.
+    *          Selected node or {@code null} for an empty tree.
+    * @param   width
+    *          widget width.
+    * @param   height
+    *          widget height.
     * @param   selectionBack
-    *          Selection back color.
+    *          Selection background color.
     * @param   selectionFore
     *          Selection foreground color.
-    * @param   disabledFore
-    *          Disabled widget foreground color.
-    * @param   imageListId
-    *          Widget id of the image list assignd to the tree.
     */
-   private void drawTreeViewNode(final GuiDriver gd,
-                                 final GuiColorResolver gc,
-                                 final TreeGuiImpl tree,
-                                 final TreeGuiImpl.TreeNode node,
-                                 final TreeGuiImpl.TreeNode currentNode,
-                                 final int valueIndex,
-                                 final int rowIdx,
-                                 final int parentRowIdx,
-                                 final int prevExpIcoRowIdx,
-                                 final GuiFontResolver.FontCache font,
-                                 final int nodeHeight,
-                                 final int rowWidth,
-                                 final int level,
-                                 final boolean enabled,
-                                 final boolean firstChild,
-                                 final boolean lastChild,
-                                 final boolean showExpandIcon,
-                                 final ColorRgb selectionBack,
-                                 final ColorRgb selectionFore,
-                                 final ColorRgb disabledFore,
-                                 final int imageListId)
+   public final void drawTreeListBody(final GuiDriver gd,
+                                      final GuiColorResolver gc,
+                                      final GuiFontResolver.FontCache fc,
+                                      final TreeListGuiImpl tree,
+                                      final TreeNode topNode,
+                                      final TreeNode currentNode,
+                                      final int width,
+                                      final int height,
+                                      final ColorRgb selectionBack,
+                                      final ColorRgb selectionFore)
    {
-      final Object value = node.value.getValue(valueIndex);
-      
-      final String text = value == null ? "" : value.toString();
-
-      int contentX = getTreeViewNodeContentHorizontalOffset(level);
-      
-      int textY = getTreeViewNodeVerticalOffset(rowIdx, nodeHeight, font);
-
-      // node image if defined
-      // selected item needs special background and foreground
-      final boolean nodeSelected = node == currentNode;
-      final ImageWrapper img = tree.getNodeImage(node, nodeSelected);
-
-      final int imageWidth;
-      if (img != null)
-      {
-         imageWidth = img.getWidth();      
-         final int imageHeight = img.getHeight();
-         final int imageY = getTreeViewNodeImageVerticalOffset(rowIdx, nodeHeight, imageHeight);         
-         gd.drawImage(img,
-                      contentX, imageY,
-                      imageWidth, imageHeight, 0, 0,
-                      false, false, false, false);
-      }
-      else
-      {
-         imageWidth = 0;               
-      }
-
-      final int textX = getTreeViewNodeLabelHorizontalOffset(level, imageWidth);
-      
-      // node text highlight
-      if (nodeSelected)
-      {
-         gd.setColor(selectionBack);
-         gd.fillRect(textX, nodeHeight * rowIdx, rowWidth, nodeHeight);
-      }
-
-      // node text color
-      final ColorRgb textColor;
-      if (enabled && nodeSelected)
-      {
-         textColor = selectionFore;
-      }
-      else if (enabled)
-      {
-         textColor = gc.fgColor;
-      }
-      else
-      {
-         textColor = disabledFore;
-      }
-
-      // node text
-      gd.setColor(textColor);
-      gd.drawString(text, textX + 2, textY);
-      
-      final int signX = TREEVIEW_INNER_PADDING +
-                  TREEVIEW_EXPAND_ICON_OFFSET +
-                  getTreeViewNodeHorizontalOffset(level - 1);
-
-      final int iconY = nodeHeight * rowIdx + (nodeHeight - TREEVIEW_EXPAND_ICON_SIZE) / 2;
+      final FontDetails font = fc.font;
+      gd.setGuiFont(font);
+      gd.setFontStyle(font.style);
+
+      // fill the background
+      final ColorRgb bgColor = gc.bgColor;
+      gd.setColor(bgColor);
+      gd.fillRect(0, 0, width, height);
+
+      final List<ColumnCache> columns = tree.columns;
+      if (columns.isEmpty() || topNode == null)
+      {
+         return;
+      }
+
+      // Collect visible nodes that fit into the widget height, their row numbers and parents
+      final Map<TreeNode, Integer> node2row = new IdentityHashMap<>();
+      final Set<TreeNode> parents = Collections.newSetFromMap(new IdentityHashMap<>()); 
+      final int rowHeight = getTreeViewNodeHeight(fc);
+      final int nodesFit = (height + rowHeight - 1) / rowHeight;
+      int row = 0; 
+      for (TreeNode node = topNode; node != null && row < nodesFit; node = node.nextVisible())
+      {
+         node2row.put(node, Integer.valueOf(row));
+         parents.add(node.parent);
+         row++; 
+      }
+      
+      // Assure ancestors of the top node are added too.
+      for (TreeNode p = topNode.parent; p != null; p = p.parent)
+      {
+         parents.add(p);
+      }
+      
       final int signOff = TREEVIEW_EXPAND_ICON_SIZE / 2;
-      final int hSignOff = signOff / 2;
 
-      // horizontal dots
+      // draw vertical lines from parents down to the last children
       gd.setColor(TREEVIEW_DOTS_COLOR);
-      for (int i = 0; i < (contentX - signX - signOff - 1) / 2; i++)
-      {
-         final int x = signX + signOff + (i + 1) * 2;
-         final int y = iconY + signOff;
-         gd.drawLine(x, y, x, y);
-      }
-
-      // vertical dots
-      if (showExpandIcon || lastChild)
-      {
-         final int topY;
-         if (prevExpIcoRowIdx < 0)
+      for (final TreeNode p : parents)
+      {
+         final int level = p.getLevel();
+         final int expandIconLeftX = TREEVIEW_INNER_PADDING + TREEVIEW_EXPAND_ICON_OFFSET
+                  + getTreeViewNodeHorizontalOffset(level);
+         final int verticalDotsX = expandIconLeftX + signOff;
+         // Make sure the line from the very first real tree node to the virtual tree root
+         // is not drawn
+         final int lineTop;
+         final int halfRowHeight = rowHeight / 2;
+         if (p.parent == null && topNode.parent == p && p.nodes.get(0) == topNode)
          {
-            // connecting to the very first node or the parent node text
-            topY = level == 0 ? nodeHeight / 2 : nodeHeight * (parentRowIdx + 1);
+            lineTop = halfRowHeight;
          }
          else
          {
-            // connecting to the previous expand icon
-            topY = nodeHeight * (prevExpIcoRowIdx + 1) - ((nodeHeight - TREEVIEW_EXPAND_ICON_SIZE) / 2);
+            final Integer parentRow = node2row.get(p);
+            lineTop = parentRow != null ? rowHeight * parentRow.intValue() + halfRowHeight : 0;
          }
+         final List<TreeNode> children = p.nodes;
+         final TreeNode lastChild = children.get(children.size() - 1);
 
-         // when first child give room to the parent node text
-         for (int i = topY; i < (showExpandIcon ? iconY : iconY + signOff + 1); i += 2)
+         // Skip lines completely above the visible area
+         if (lastChild != topNode && lastChild.isDFTBeforeThan(topNode))
          {
-            final int x = signX + signOff;
-            gd.drawLine(x, i, x, i);
+            continue;
          }
+         
+         final Integer lastChildRow = node2row.get(lastChild);
+         final int bottom = lastChildRow != null
+                  ? rowHeight * lastChildRow.intValue() + halfRowHeight
+                  : height;
+         drawDottedVerticalLine(gd, verticalDotsX, lineTop, bottom);
       }
-
-      if (showExpandIcon)
+      
+      final TreeConfig c = tree.config();
+      final boolean configShowExpandIcon = c.showExpandIcon;
+      final int hSignOff = signOff / 2;
+      
+      //////////////////////////////////////////////////
+      // Do the drawing
+      //////////////////////////////////////////////////
+      
+      final ColorRgb fgColor = gc.fgColor;
+      for (final TreeNode node : node2row.keySet())
       {
-         // the expand icon border
+         final int level = node.getLevel();
+         final int contentX = getTreeViewNodeContentHorizontalOffset(level);
+         final int expandIconLeftX = TREEVIEW_INNER_PADDING + TREEVIEW_EXPAND_ICON_OFFSET
+                  + getTreeViewNodeHorizontalOffset(level - 1);
+
+         row = node2row.get(node).intValue();
+         final int rowTop = rowHeight * row;
+         final int iconY = rowTop + (rowHeight - TREEVIEW_EXPAND_ICON_SIZE) / 2;
+
+         // horizontal dots from the center of expand icon to the center of node icon.
          gd.setColor(TREEVIEW_DOTS_COLOR);
-         gd.drawRect(signX, iconY, TREEVIEW_EXPAND_ICON_SIZE - 1, TREEVIEW_EXPAND_ICON_SIZE - 1);
-
-         // the - collapse sign
-         gd.setColor(TREEVIEW_EXPAND_ICON_COLOR);
-         gd.drawLine(signX + hSignOff, iconY + signOff, signX + hSignOff + signOff, iconY + signOff);
-
-         // the + expand sign
-         if (!node.value.expanded)
-         {
-            gd.drawLine(signX + signOff, iconY + hSignOff, signX + signOff, iconY + hSignOff + signOff);
+         final int horizontalDotsY = iconY + signOff;
+         final int startX = expandIconLeftX + hSignOff + 2;
+         final int endX = signOff + contentX + 3;
+         for (int x = startX; x < endX; x += 2)
+         {
+            gd.drawLine(x, horizontalDotsY, x, horizontalDotsY);
+         }
+         
+         final TreeNodeEntry nodeValue = node.value;
+         final boolean nodeSelected = node == currentNode;
+         final ImageWrapper img = tree.getNodeImage(node, nodeSelected);
+         final int imageWidth = img != null ? img.getWidth() : 0;         
+
+         boolean firstColumn = true;
+         int xOff = 0;
+         for (final TreeListGuiImpl.ColumnCache cc : columns)
+         {
+            final Column column = cc.column;
+            if (!column.visible)
+            {
+               continue;
+            }
+
+            final int textXoffset;
+            if (firstColumn)
+            {
+               textXoffset = getTreeViewNodeLabelHorizontalOffset(level, imageWidth);
+               firstColumn = false;
+               // node icon
+               if (img != null)
+               {
+                  final int imageHeight = img.getHeight();
+                  final int imageY = rowTop + (rowHeight - imageHeight) / 2;
+                  gd.drawImage(img, contentX - 2, imageY, imageWidth, imageHeight, 0, 0, false,
+                           false, false, false);
+               }
+
+               // Expand/collapse button
+               if (configShowExpandIcon && nodeValue.hasChildren)
+               {
+                  final int expandIconDimension = TREEVIEW_EXPAND_ICON_SIZE - 1;
+
+                  // Button background
+                  gd.setColor(bgColor);
+                  gd.fillRect(expandIconLeftX, iconY, expandIconDimension, expandIconDimension);
+
+                  // Button border
+                  gd.setColor(TREEVIEW_DOTS_COLOR);
+                  gd.drawRect(expandIconLeftX, iconY, expandIconDimension, expandIconDimension);
+
+                  // the "-" sign line
+                  gd.setColor(TREEVIEW_EXPAND_ICON_COLOR);
+                  gd.drawLine(expandIconLeftX + hSignOff, iconY + signOff,
+                           expandIconLeftX + hSignOff + signOff, iconY + signOff);
+
+                  // the line tom make "+" sign
+                  if (!node.value.expanded)
+                  {
+                     gd.drawLine(expandIconLeftX + signOff, iconY + hSignOff,
+                              expandIconLeftX + signOff, iconY + hSignOff + signOff);
+                  }
+               }
+            }
+            else
+            {
+               textXoffset = 0;
+            }
+ 
+            final int index = cc.index;
+            final Object value = nodeValue.getValue(index);      
+            final int colWidth = column.width;
+
+            final NativePoint p = new NativePoint(xOff + textXoffset, rowTop);
+            final NativeDimension dim = new NativeDimension(colWidth - textXoffset, rowHeight);
+            final NativeRectangle clip = AbstractWidget.clipRectangle(p, dim);
+            
+            gd.draw(p, clip, () -> {
+               final List<ColorRgb> bgColors = ((TreeListNodeEntry) nodeValue).cellBGColors;
+               ColorRgb effBgColor = index < bgColors.size() ? bgColors.get(index) : null;
+
+               if (effBgColor == null)
+               {
+                  final ColorRgb columnBgColor = column.bgColor;
+                  effBgColor = columnBgColor != null ? columnBgColor : bgColor;
+               }
+
+               final List<ColorRgb> fgColors = ((TreeListNodeEntry) nodeValue).cellFGColors;
+               ColorRgb effFgColor = index < fgColors.size() ? fgColors.get(index) : null;
+               if (effFgColor == null)
+               {
+                  final ColorRgb columnFgColor = column.fgColor;
+                  effFgColor = columnFgColor != null ? columnFgColor : fgColor;
+               }
+
+               drawTreeListCell(gd, fc, tree, colWidth, rowHeight, effFgColor, selectionBack,
+                        effBgColor, value, column.align, nodeSelected, column.dataType);
+            });
+
+            xOff += colWidth;
          }
       }
    }
@@ -6959,6 +7203,7 @@
     * @param   flat
     *          Is tab button flat?
     */
+   @SuppressWarnings("static-method")
    private void drawTabSetButton(GuiDriver gd,
                                  int x,
                                  int y,
@@ -7145,88 +7390,6 @@
    }
    
    /**
-    * Draws TREELIST body.
-    *
-    * @param   gd
-    *          GUI driver.
-    * @param   gc
-    *          Color resolver.
-    * @param   font
-    *          Text font.
-    * @param   tree
-    *          Tree widget instance.
-    * @param   nodes
-    *          Root tree nodes to render.
-    * @param   currentNode
-    *          Selected tree node.
-    * @param   bodyDim
-    *          Tree widget body dimension.
-    * @param   selectionBg
-    *          Selection tree node background color.
-    * @param   selectionFg
-    *          Selection tree node foreground color.
-    * @param   disabledFore
-    *          Text color for the disabled tree node.
-    * @param   columns
-    *          Tree list columns.
-    */
-   public <N extends TreeNodeEntry> void drawTreeListBody(GuiDriver gd,
-                                                          final GuiColorResolver gc,
-                                                          final GuiFontResolver.FontCache font,
-                                                          final TreeListGuiImpl tree,
-                                                          final List<TreeGuiImpl.TreeNode<N>> nodes,
-                                                          final TreeGuiImpl.TreeNode<N> currentNode,
-                                                          final NativeDimension bodyDim,
-                                                          final ColorRgb selectionBg,
-                                                          final ColorRgb selectionFg,
-                                                          final ColorRgb disabledFore,
-                                                          final List<TreeListGuiImpl.ColumnCache> columns)
-   {
-      gd.setGuiFont(font.font);
-      gd.setFontStyle(font.font.style);
-
-      // fill the background
-      gd.setColor(gc.bgColor);
-      gd.fillRect(0, 0, bodyDim.width, bodyDim.height);
-
-      if (columns.isEmpty())
-      {
-         return;
-      }
-
-      // the first column will be rendered as tree view body
-      // Note: we need to limit the width by the first column only width.
-      final int firstVisibleColumnIndex = tree.getFirstVisibleColumnIndex();
-      final int width = columns.get(firstVisibleColumnIndex).column.width;
-      drawTreeViewBody(gd,
-                       gc,
-                       font,
-                       tree,
-                       nodes,
-                       currentNode,
-                       firstVisibleColumnIndex,
-                       width,
-                       selectionBg,
-                       selectionFg,
-                       disabledFore);
-
-
-      final int nodeHeight = getTreeViewNodeHeight(font);
-
-      drawTreeListNodes(gd,
-                        gc,
-                        font,
-                        tree,
-                        nodes,
-                        currentNode,
-                        0,
-                        selectionBg,
-                        selectionFg,
-                        columns,
-                        nodeHeight);
-   }
-
-   /**
     * Draws TREELIST caption.
     *
     * @param   gd
@@ -7238,10 +7401,11 @@
     * @param   height
     *          Caption height.
     */
-   public final void drawTreeListCaption(GuiDriver gd,
-                                   GuiColorResolver gc,
-                                   int width,
-                                   int height)
+   @SuppressWarnings("static-method")
+   public final void drawTreeListCaption(final GuiDriver gd,
+                                         final GuiColorResolver gc,
+                                         final int width,
+                                         final int height)
    {
       gd.setColor(TREELIST_CAPTION_COLOR);
       gd.fillRect(0, 0, width, height);
@@ -7265,6 +7429,7 @@
     * @param   isLast
     *          the caption it the last caption from the right
     */
+   @SuppressWarnings("static-method")
    public final void drawTreeListCaptionItem(final GuiDriver gd,
                                              final GuiColorResolver gc,
                                              final GuiFontResolver.FontCache font,
@@ -7400,7 +7565,7 @@
     *
     * @param   gd
     *          GUI driver.
-    * @param   font
+    * @param   fc
     *          Text font.
     * @param   tree
     *          Treelist instance.
@@ -7422,22 +7587,22 @@
     *            The column data type: 0 for string, 4 for icon
     */
    private void drawTreeListCell(final GuiDriver gd,
-                                 final GuiFontResolver.FontCache font,
+                                 final GuiFontResolver.FontCache fc,
                                  final TreeListGuiImpl tree,
                                  final int width,
                                  final int rowHeight,
                                  final ColorRgb fgColor,
-                                 final ColorRgb bgSelColor,
+                                 final ColorRgb selectionBack,
                                  final ColorRgb bgColor,
                                  Object value,
                                  final byte align,
                                  final boolean selected,
                                  final TreeListConfig.Column.DataType dataType)
    {
-      final int labelHeight = getTreeViewNodeLabelHeight(font);
+      final int labelHeight = getTreeViewNodeLabelHeight(fc);
       final int fillBgAreaHeight = Math.max(rowHeight, labelHeight);
 
-      gd.setColor(selected ? bgSelColor : bgColor);
+      gd.setColor(selected ? selectionBack : bgColor);
       gd.fillRect(0, 0, width, fillBgAreaHeight);
 
       if (value == null)
@@ -7452,7 +7617,7 @@
             gd.setColor(fgColor);
 
             final String textToDraw = value.toString().replaceFirst("\\s+$", "");
-            final int textWidth = tree.getTextWidth(textToDraw, font.font);
+            final int textWidth = tree.getTextWidth(textToDraw, fc.font);
 
             final int textXOffset;
             switch (align)
@@ -7472,7 +7637,7 @@
                   textXOffset = TREELIST_COLUMN_CAPTION_LEFT_PADDING;
             }
 
-            final int textY = getTreeViewNodeVerticalOffset(0, rowHeight, font);
+            final int textY = getTreeViewNodeVerticalOffset(0, rowHeight, fc);
             gd.drawString(textToDraw, Math.max(TREELIST_COLUMN_CAPTION_LEFT_PADDING, textXOffset),
                      textY);
             return;
@@ -7485,7 +7650,7 @@
                {
                   id = Integer.parseInt(((String) value).trim());
                }
-               catch (NumberFormatException e)
+               catch (@SuppressWarnings("unused") NumberFormatException e)
                {
                   return;
                }
